"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.search_radio = void 0;
const DEF_MODE = 'name';
const BASE_URL = 'http://all.api.radio-browser.info/json/stations/search';
const MODES = ['name', 'tag', 'country', 'language'];
function search_radio(search, mode) {
    if (!MODES.includes(mode)) {
        mode = DEF_MODE;
    }
    return new Promise((resolve, reject) => {
        const options = {
            method: 'GET',
            url: BASE_URL + "?" + mode + "=" + search.split(' ').join('+')
        };
        require('request')(options, (err, _, body) => {
            if (err) {
                reject(err);
            }
            else {
                const json = JSON.parse(body);
                resolve(parse_radio(json));
            }
        });
    });
}
exports.search_radio = search_radio;
function parse_radio(json) {
    return Object.keys(json).map((key) => ({
        name: json[key].name,
        homepage: json[key].homepage,
        listeners: 'Null',
        description: 'Null',
        playing: 'Null',
        url: json[key].url,
        src: 'Radio',
        bitrate: json[key].bitrate,
        is_playlist: /\.m3u|\.pls/.test(json[key].url),
        entry: json[key]
    }));
}
